/*
 * Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana
 *
 * This file is part of blendb.
 *
 * blendb is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * blendb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with blendb.  If not, see <http://www.gnu.org/licenses/>.
 */

const miss = require("mississippi");
const uuid = require("node-uuid");

export class View {
    public id: string;

    private data: any[];

    constructor() {
        this.id = uuid.v4();
        this.data = new Array();
    }

    public sink() {
        function write(data: any, enc: string, cb: Function) {
            this.data.push(data);
            cb();
        }

        function flush(cb: Function) {
            cb();
        }

        return miss.to.obj(write, flush);
    }
}
